#
# Conditional build:
%bcond_with	apidocs # don't generate apidocs subpackage
%bcond_without	gui # don't build Qt GUI tool

Summary:	A source code converter to HTML, XHTML, RTF, TeX, LaTeX, XSL-FO, and XML
Summary(pl.UTF-8):	Konwerter kodu źródłowego do formatów HTML, XHTML, RTF, TeX, LaTeX, XSL-FO oraz XML
Name:		highlight
Version:	4.1
Release:	1
License:	GPL v3
Group:		Applications/Publishing
Source0:	http://www.andre-simon.de/zip/%{name}-%{version}.tar.bz2
# Source0-md5:	65caf60e800bb8badf42aac523d48858
Patch0:		%{name}-Makefile.patch
URL:		http://www.andre-simon.de/
BuildRequires:	boost-devel
%{?with_apidocs:BuildRequires:	doxygen}
BuildRequires:	libstdc++-devel
BuildRequires:	lua-devel >= 5.3
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.752
%if %{with gui}
BuildRequires:	Qt5Core-devel
BuildRequires:	Qt5Gui-devel
BuildRequires:	Qt5Widgets-devel
BuildRequires:	qt5-build
BuildRequires:	qt5-qmake
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sysconfdir	/etc/highlight

%description
Highlight is a universal converter from source code to HTML, XHTML,
RTF, TeX, LaTeX, XSL-FO, and XML. (X)HTML output is formatted by
Cascading Style Sheets. It supports 100 programming languages and
includes 50 highlighting color themes. It's possible to easily enhance
the parsing database. The converter includes some features to provide
a consistent layout of the input code.

%description -l pl.UTF-8
Highlight jest uniwersalnym konwerterem kodu źródłowego do formatów
HTML, XHTML, RTF, TeX, LaTeX, XSL-FO, and XML. Wyjście (X)HTML jest
formatowane przez kaskadowe arkusze stylów (CSS). Highlight wspiera
100 języków programowania i zawiera 50 kolorystycznych motywów
podświetlania składni. Umożliwia łatwe ulepszanie bazy parsowania.
Konwerter zawiera pewne cechy zapewniające spójny układ graficzny kodu
wejściowego.

%package apidocs
Summary:	API documentation for highlight - a source code converter to HTML, XHTML, RTF, TeX, LaTeX, XSL-FO, and XML
Summary(pl.UTF-8):	Dokumentacja API highlight - konwertera kodu źródłowego do HTML, XHTML, RTF, TeX, LaTeX, XSL-FO oraz XML
Group:		Documentation
BuildArch:	noarch

%description apidocs
API documentation for highlight - a source code converter to HTML,
XHTML, RTF, TeX, LaTeX, XSL-FO, and XML.

%description apidocs -l pl.UTF-8
Dokumentacja API highlight - konwertera kodu źródłowego do formatu
HTML, XHTML, RTF, TeX, LaTeX, XSL-FO oraz XML.

%package gui
Summary:	GUI for highlight - a source code converter to HTML, XHTML, RTF, TeX, LaTeX, XSL-FO, and XML
Summary(pl.UTF-8):	GUI do highlight - konwertera kodu źródłowego do HTML, XHTML, RTF, TeX, LaTeX, XSL-FO oraz XML
Group:		Development/Tools
Requires:	%{name}
Requires(post,postun):	gtk-update-icon-cache
Requires:	hicolor-icon-theme

%description gui
Qt4 GUI for for highlight - a source code converter to HTML, XHTML,
RTF, TeX, LaTeX, XSL-FO, and XML.

%prep
%setup -q
%patch0 -p1

%build
%{__make} \
	CXX="%{__cxx}" \
	CXXFLAGS="%{rpmcxxflags} -std=c++11" \
	LUA_PKG_NAME="lua"
%if %{with gui}
%{__make} gui \
	QMAKE=qmake-qt5 \
	CXX="%{__cxx}"
%endif

%{?with_apidocs:%{__make} apidocs}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%if %{with gui}
%{__make} install-gui \
	DESTDIR=$RPM_BUILD_ROOT
%endif

# to avoid false `warning: Installed (but unpackaged) file(s) found:' - these files are packaged through %doc
rm -fr $RPM_BUILD_ROOT%{_docdir}/highlight

%clean
rm -rf $RPM_BUILD_ROOT

%post gui
%update_icon_cache hicolor

%postun gui
%update_icon_cache hicolor

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog.adoc README.adoc README_LANGLIST.adoc README_PLUGINS.adoc README_REGEX.adoc extras
%lang(de) %doc README_DE.adoc
%attr(755,root,root) %{_bindir}/%{name}
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/langDefs
%dir %{_datadir}/%{name}/plugins
%{_datadir}/%{name}/plugins/*.lua
%{_datadir}/%{name}/themes
%{_mandir}/man1/highlight.1*
%{_mandir}/man5/filetypes.conf.5*
%dir %{_sysconfdir}
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/*

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%doc apidocs/html/*
%endif

%if %{with gui}
%files gui
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/%{name}-gui
%dir %{_datadir}/%{name}/gui_files
%dir %{_datadir}/%{name}/gui_files/l10n
%lang(bg) %{_datadir}/%{name}/gui_files/l10n/highlight_bg_BG.qm
%lang(cs) %{_datadir}/%{name}/gui_files/l10n/highlight_cs_CZ.qm
%lang(de) %{_datadir}/%{name}/gui_files/l10n/highlight_de_DE.qm
%lang(es) %{_datadir}/%{name}/gui_files/l10n/highlight_es_ES.qm
%lang(fr) %{_datadir}/%{name}/gui_files/l10n/highlight_fr_FR.qm
%lang(it) %{_datadir}/%{name}/gui_files/l10n/highlight_it_IT.qm
%lang(zh) %{_datadir}/%{name}/gui_files/l10n/highlight_zh_CN.qm
%{_datadir}/%{name}/gui_files/ext
%{_desktopdir}/*.desktop
%{_iconsdir}/hicolor/*x*/apps/highlight.png
%endif
%changelog
* Thu Jun 03 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/highlight.git;a=log;h=master

* Wed Jun 02 2021 Jan Palus <atler@pld-linux.org> 10fa87e
- up to 4.1

* Wed Jun 02 2021 Jan Palus <atler@pld-linux.org> 5126db6
- build against unversioned lua

* Tue Jun 01 2021 Jan Palus <atler@pld-linux.org> 684b845
- plugins belong to base package

* Tue Jun 01 2021 Jan Palus <atler@pld-linux.org> d9d6f1d
- add gui bcond

* Tue Jun 01 2021 Jan Palus <atler@pld-linux.org> a0820ab
- rediff patch

* Sun Mar 07 2021 Jan Rękorajski <baggins@pld-linux.org> 1c10d6a
- unconditional noarch subpackages

* Sat Jan 16 2021 Jan Palus <atler@pld-linux.org> 2c97026
- updated noarch rule

* Sat Jan 16 2021 Jan Palus <atler@pld-linux.org> 13b9f4a
- up to 3.60

* Sun Nov 08 2020 Jan Palus <atler@pld-linux.org> 3c088a8
- up to 3.58

* Sun Nov 08 2020 Jan Palus <atler@pld-linux.org> 710c3d4
- translation files are not directories

* Tue Aug 06 2019 Adam Gołębiowski <adamg@pld-linux.org> b749765
- updated to 3.53

* Sat May 18 2019 Adam Gołębiowski <adamg@pld-linux.org> c0a8e53
- updated to 3.51

* Sun Mar 31 2019 Adam Gołębiowski <adamg@pld-linux.org> d9b13a3
- updated to 3.50

* Tue Feb 26 2019 Jan Palus <atler@pld-linux.org> d1a9fc6
- rely on qmake's CXXFLAGS; rel 2

* Mon Feb 25 2019 Jan Palus <atler@pld-linux.org> 03025ef
- up to 3.49

* Tue Jan 24 2017 Jan Palus <atler@pld-linux.org> 9d86d0c
- up to 3.34

* Sun Jul 24 2016 Jan Palus <atler@pld-linux.org> 7a8012a
- up to 3.30

* Sat May 07 2016 Jan Rękorajski <baggins@pld-linux.org> 6f17451
- force moc regeneration
- rel 3

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> 6dca621
- noarch apidoc

* Tue May 25 2010 Szymon Siwek <sls@pld-linux.org> 0cf9473
- ver. 2.16

